#include<bits/stdc++.h>
using namespace std;

const int N = 4e5 + 10;

int r[N * 2];
string s;
int n;

void manacher() {
    r[0] = 0;
    int k = 0;
    for (int i = 0; i < n*2; ++i) {
        r[i] = min(r[2*k - i], k + r[k] - i);
        while (i-r[i] >= 0 && s[i + r[i] + 1] == s[i - r[i]]) r[i]++; 
        if (r[i] + i > k + r[k]) k = i;
        // cout << i << ": " << r[i] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    string input;
    cin >> n >> input;
    for (auto c : input) {
        s.push_back(c);
        s.push_back(c);
    }
    s.push_back('#');
    manacher();

    if (n == 1) {
    cout << 0 << "\n";
    return 0;
    } 
    int ans = n-1;
    for (int i = 0 ; i < n; ++i) {
        // cout << i << ": " << r[i*2] << " " << r[i*2 + 1] << "\n";
        
        if (i + r[i*2 + 1]/2 + 1 == n) {
            ans = min(ans, i - r[i*2+1]/2 + 1);
            // return 0;
        }
        if (i + r[i*2]/2 + 1 == n) {
            ans = min(ans, i - r[i*2]/2);
            // return 0;
        }
    } 
    cout << ans << "\n";
}